## coin3 3.1.4~abc9f50+dfsg3

=== debian/changelog ===
coin3 (3.1.4~abc9f50+dfsg3-2) unstable; urgency=medium

  * Team upload.
  * [e6b5281] Use SbHash-file from the current upstream version. (Closes: #884947)
  * [6628274] Set Standards-Version to 4.1.3
  * [47240a4] Update VCS-field

 -- Anton Gladky <gladk@debian.org>  Fri, 29 Dec 2017 00:27:37 +0100

coin3 (3.1.4~abc9f50+dfsg3-1) unstable; urgency=medium

  * [2b9d334] Revert the previoud removal of embedded expat. (Closes: #884947)
  * [7b2c782] New upstream version 3.1.4~abc9f50+dfsg3

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Dec 2017 09:50:10 +0100

=== debian/control ===
Source: coin3
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Section: graphics
Testsuite: autopkgtest
Priority: optional
Build-Depends: debhelper (>= 10),
               autotools-dev,
               doxygen,
               libgl1-mesa-dev,
               libx11-dev,
               libexpat-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxpm-dev,
               libxt-dev,
               libboost-all-dev
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/coin3
Vcs-Git: https://salsa.debian.org/science-team/coin3.git
Homepage: https://bitbucket.org/Coin3D/coin/

Package: libcoin80v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbz2-1.0,
          libfreetype6,
          libopenal0a,
          libsimage-dev,
          zlib1g
Pre-Depends: ${misc:Pre-Depends}
Breaks: libcoin80
Replaces: libcoin80
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin80-dev
Architecture: any
Section: libdevel
Depends: libcoin80v5 (= ${binary:Version}),
         libgl1-mesa-dev | libgl-dev,
         libx11-dev,
         libxext-dev,
         libxi-dev,
         libxmu-dev,
         libxpm-dev,
         libxt-dev,
         ${misc:Depends}
Suggests: libcoin80-doc (= ${binary:Version})
Conflicts: inventor-dev,
           libcoin20-dev,
           libcoin40-dev,
           libcoin60-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin80-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libcoin80-dev (= ${binary:Version})
Conflicts: inventor-dev,
           libcoin20-doc,
           libcoin40-doc,
           libcoin60-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 manpage and HTML format.

Package: libcoin80-runtime
Architecture: all
Section: libs
Depends: ${misc:Depends}
Suggests: libcoin80v5
Conflicts: libcoin20-runtime,
           libcoin40-runtime,
           libcoin60-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autotools_dev --without autoreconf

DEB_CONFIGURE_EXTRA_FLAGS = \
	--disable-dependency-tracking \
	--enable-static \
	--enable-shared \
	--disable-maintainer-mode \
	--enable-html htmldir=/usr/share/doc/libcoin80-doc/html \
	--without-mesa \
	--enable-threadsafe \
	--enable-system-expat

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CONFIGURE_EXTRA_FLAGS)

=== debian/tests/control ===
Tests: build1
Depends: libcoin80-dev, freeglut3-dev, build-essential, xvfb, xauth

## coin3 4.0.0~CMake~6f54f1602475+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(COIN_MAJOR_VERSION 4)
set(COIN_MINOR_VERSION 0)
set(COIN_MICRO_VERSION 0)
set(COIN_BETA_VERSION a)
set(COIN_VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION}${COIN_BETA_VERSION})

project(Coin VERSION ${COIN_MAJOR_VERSION}.${COIN_MINOR_VERSION}.${COIN_MICRO_VERSION})
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

string(TIMESTAMP COIN_BUILD_YEAR "%Y")
math(EXPR COIN_SO_VERSION ${PROJECT_VERSION_MAJOR}*20)

# ############################################################################
# these will be removed after upgrading CMake minimum version
set(PROJECT_DESCRIPTION   "A high-level 3D visualization library with Open Inventor 2.1 API")
# ############################################################################

if(POLICY CMP0072)
  # get rid of OpenGL GLVND warning from CMake 3.11
  cmake_policy(SET CMP0072 NEW)
endif()

# ############################################################################
# Prevent insource builds, as they often cause severe build problems
# ############################################################################

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "${CMAKE_PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake <path_to_${CMAKE_PROJECT_NAME}> [options]' from there.")
endif()

# ############################################################################
# Include necessary submodules
# ############################################################################

# Add path for Coin specific utility scripts
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

include(CheckCSourceRuns)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckTypeSize)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(FeatureSummary)
include(CoinCMakeUtilities)

# ############################################################################
# Provide options to customise the build
# ############################################################################

option(COIN_BUILD_SHARED_LIBS "Build shared library when ON (default), static when OFF." ON)
option(COIN_BUILD_TESTS "Build unit tests when ON (default), skips them when OFF." ON)
option(COIN_BUILD_DOCUMENTATION "Build and install API documentation (requires Doxygen)." ON)
cmake_dependent_option(COIN_BUILD_INTERNAL_DOCUMENTATION "Document internal code not part of the API." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_MAN "Build Coin man pages." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_QTHELP "Build QtHelp documentation." OFF "COIN_BUILD_DOCUMENTATION" OFF)
cmake_dependent_option(COIN_BUILD_DOCUMENTATION_CHM "Build compressed HTML help manual (requires HTML help compiler)" OFF "COIN_BUILD_DOCUMENTATION" OFF)

option(COIN_THREADSAFE "Enable thread safe render traversals." OFF)
option(HAVE_VRML97 "Enable VRML97 support." ON)
cmake_dependent_option(COIN_HAVE_JAVASCRIPT "Enable JavaScript capabilities for VRML97." ON "HAVE_VRML97" OFF)
option(HAVE_NODEKITS "Enable NodeKit support." ON)
cmake_dependent_option(HAVE_DRAGGERS "Enable Dragger support." ON "HAVE_NODEKITS" OFF)
cmake_dependent_option(HAVE_MANIPULATORS "Enable Manipulator support." ON "HAVE_NODEKITS" OFF)
option(HAVE_SOUND "Enable OpenAL sound support." ON)
option(HAVE_3DS_IMPORT_CAPABILITIES "Enable 3ds import capabilities." ON)
option(USE_EXTERNAL_EXPAT "Use system install of Expat." OFF)
option(USE_EXCEPTIONS "Compile with exceptions (g++ only)." ON)
option(USE_SUPERGLU "Use superglu library when ON, GLU implementation of platform when OFF (default)." OFF)

option(FONTCONFIG_RUNTIME_LINKING   "Enable FontConfig runtime linking when ON (default), disable when OFF." ON)
option(FREETYPE_RUNTIME_LINKING     "Enable FreeType runtime linking when ON (default), disable when OFF." ON)
option(LIBBZIP2_RUNTIME_LINKING     "Enable libBZip2 runtime linking when ON (default), disable when OFF." ON)
option(OPENAL_RUNTIME_LINKING       "Enable OpenAL runtime linking when ON (default), disable when OFF." ON)
option(SIMAGE_RUNTIME_LINKING       "Enable simage runtime linking when ON (default), disable when OFF" ON)
option(ZLIB_RUNTIME_LINKING         "Enable ZLib runtime linking when ON (default), disable when OFF." ON)
option(GLU_RUNTIME_LINKING          "Enable GLU runtime linking when ON (default), disable when OFF." ON)
option(SPIDERMONKEY_RUNTIME_LINKING "Enable SpiderMonkey runtime linking when ON (default), disable when OFF." ON)

option(COIN_VERBOSE "Add verbose debugging information during the configure process." OFF)
option(HAVE_MULTIPLE_VERSION "Forces versioned paths for includes and documentation when ON, usual behaviour otherwise." OFF)

if(HAVE_MULTIPLE_VERSION)
  # Modifies the installation path for both the distributed includes and docs
  versionize(INCLUDEDIR DOCDIR)
  dump_variable(CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_FULL_INCLUDEDIR CMAKE_INSTALL_DOCDIR CMAKE_INSTALL_FULL_DOCDIR)
endif()

# ############################################################################
# Find all necessary and optional Coin3D dependencies
# ############################################################################

# Fail early if one of the required packages cannot be found

# This is needed when Coins local Boost includes are removed and system installation of Boost is used.
#find_package(Boost REQUIRED) # almost any Boost will do
#list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES ${Boost_INCLUDE_DIRS})

# As not all CMake FindXXX modules and config packages provide target support,
# we should explicitly check for them on.
find_package(OpenGL REQUIRED)
if(OPENGL_FOUND)
  set(HAVE_OPENGL 1)
  set(OPENGL_SYSTEM_LIBRARY_NAME "${OPENGL_gl_LIBRARY}${CMAKE_SHARED_LIBRARY_SUFFIX}")
  if(OpenGL_GLU_FOUND)
    set(HAVE_GLU 1)
  endif()
  if(APPLE)
    set(GLU_IS_PART_OF_GL 1)
  endif()
  #include_directories("${OPENGL_INCLUDE_DIR}")
  if (NOT TARGET OpenGL::GL)
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${OPENGL_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${OPENGL_gl_LIBRARY}" "${OPENGL_glu_LIBRARY}")
  else()
    list(APPEND COIN_TARGET_LINK_LIBRARIES OpenGL::GL OpenGL::GLU)
  endif()
endif()

set(CMAKE_THREAD_PREFER_PTHREAD 1)
find_package(Threads)
if(Threads_FOUND)
  set(HAVE_THREADS 1)
  if(CMAKE_USE_WIN32_THREADS_INIT)
    set(USE_W32THREAD 1)
    set(COIN_THREADID_TYPE DWORD)
  elseif(CMAKE_USE_PTHREADS_INIT)
    set(USE_PTHREAD 1)
    set(COIN_THREADID_TYPE pthread_t)
  endif()
  #include_directories("${THREADS_INCLUDE_DIRS}")
  if (NOT TARGET Threads::Threads)
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${THREADS_INCLUDE_DIRS}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}")
  else()
    list(APPEND COIN_TARGET_LINK_LIBRARIES Threads::Threads)
  endif()
endif()

if(USE_EXTERNAL_EXPAT)
  find_package(EXPAT)
  if(EXPAT_FOUND)
    set(HAVE_EXPAT 1)
    #include_directories("${EXPAT_INCLUDE_DIRS}")
    if (NOT TARGET EXPAT::EXPAT)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${EXPAT_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${EXPAT_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES EXPAT::EXPAT)
    endif()
  endif()
else()
  if(NOT WIN32)
    set(XML_DEV_URANDOM 1)
  endif()
endif()

if(USE_SUPERGLU)
  find_package(superglu)
  if(superglu_FOUND)
    set(HAVE_SUPERGLU 1)
    set(GLU_RUNTIME_LINKING OFF)
    list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES "${OPENGL_glu_LIBRARY}")
    if(TARGET OpenGL::GLU)
      list(REMOVE_ITEM COIN_TARGET_LINK_LIBRARIES OpenGL::GLU)
    endif()
    list(APPEND COIN_TARGET_LINK_LIBRARIES superglu::GLU)
  endif()
endif()

#find_package(FLEX)
#if(FLEX_FOUND)
# set(HAVE_FLEX 1)
# #include_directories("${FLEX_INCLUDE_DIRS}")
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FLEX_INCLUDE_DIRS}")
#endif()
#
#find_package(BISON)
#if(BISON_FOUND)
# set(HAVE_BISON 1)
# #include_directories("${BISON_INCLUDE_DIRS}")
# #list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${BISON_INCLUDE_DIRS}")
#endif()

if(HAVE_SOUND)
  if(NOT OPENAL_RUNTIME_LINKING)
    find_package(OpenAL)
    if(OpenAL_FOUND)
      set(HAVE_OPENAL 1)
      #include_directories("${OPENAL_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${OPENAL_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${OPENAL_LIBRARY}")
      # Checks specific OpenAL configurations
      set(CMAKE_REQUIRED_INCLUDES "${OPENGL_INCLUDE_DIR}")
      check_include_file(AL/al.h HAVE_AL_AL_H)
      check_include_file(OpenAL/al.h HAVE_OPENAL_AL_H)
      set(CMAKE_REQUIRED_INCLUDES)
    endif()
  endif()
endif()

if(NOT ZLIB_RUNTIME_LINKING)
  find_package(ZLIB)
  if(ZLIB_FOUND)
    set(HAVE_ZLIB 1)
    #include_directories("${ZLIB_INCLUDE_DIRS}")
    if (NOT TARGET ZLIB::ZLIB)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${ZLIB_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${ZLIB_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES ZLIB::ZLIB)
    endif()
  endif()
endif()

if(NOT LIBBZIP2_RUNTIME_LINKING)
  find_package(BZip2)
  if(BZip2_FOUND)
    set(HAVE_BZIP2 1)
    #include_directories("${BZIP2_INCLUDE_DIRS}")
    if (NOT TARGET BZip2::BZip2)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${BZIP2_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${BZIP2_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES BZip2::BZip2)
    endif()
  endif()
endif()

if(NOT FREETYPE_RUNTIME_LINKING)
  find_package(Freetype)
  if(Freetype_FOUND)
    set(HAVE_FREETYPE 1)
    #include_directories("${FREETYPE_INCLUDE_DIRS}")
    if (NOT TARGET Freetype::Freetype)
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FREETYPE_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${FREETYPE_LIBRARIES}")
    else()
      list(APPEND COIN_TARGET_LINK_LIBRARIES Freetype::Freetype)
    endif()
    set(HAVE_FREETYPE_H 1)
  endif()
endif()

if(NOT FONTCONFIG_RUNTIME_LINKING)
  find_package(Fontconfig)
  if(FONTCONFIG_FOUND)
    set(HAVE_FONTCONFIG 1)
    #include_directories("${FONTCONFIG_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${FONTCONFIG_INCLUDE_DIR}")
    list(APPEND COIN_TARGET_LINK_LIBRARIES "${FONTCONFIG_LIBRARY}")
    set(HAVE_FONTCONFIG_H 1)
  endif()
endif()

if(HAVE_VRML97 AND COIN_HAVE_JAVASCRIPT)
  if(NOT SPIDERMONKEY_RUNTIME_LINKING)
    find_package(SpiderMonkey)
    if(SPIDERMONKEY_FOUND)
      set(HAVE_SPIDERMONKEY_VIA_LINKTIME_LINKING 1)
      #include_directories("${SPIDERMONKEY_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_INCLUDE_DIRECTORIES "${SPIDERMONKEY_INCLUDE_DIRS}")
      list(APPEND COIN_TARGET_LINK_LIBRARIES "${SPIDERMONKEY_LIBRARIES}")
      set(HAVE_SPIDERMONKEY_H 1)
    endif()
  endif()
endif()

if(NOT SIMAGE_RUNTIME_LINKING)
  find_package(simage)
  if(simage_FOUND)
    set(HAVE_LIBSIMAGE 1)
    list(APPEND COIN_TARGET_LINK_LIBRARIES simage::simage)
  endif()
endif()

message(STATUS "${COIN_TARGET_INCLUDE_DIRECTORIES}")
message(STATUS "${COIN_TARGET_LINK_LIBRARIES}")

# ##########################################################################
# Setup build environment
# ##########################################################################

if(NOT CMAKE_BUILD_TYPE)
  # Has no effect for multi configuration generators (VisualStudio, Xcode).
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose type of build, options are Debug, Release, RelWithDebInfo, MinSizeRel." FORCE)
endif()
# Set common output directories for all targets built.
# First for the generic no-config case (e.g. with mingw)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
# Second, for multi-config builds (e.g. msvc)

=== data/CMakeLists.txt ===
macro(strfy input postfx)
	get_filename_component(FLNAME "${input}" NAME_WE)
	get_filename_component(FLEXT "${input}" EXT)
	get_filename_component(FLPATH "${input}" PATH)
	string(SUBSTRING ${FLEXT} 1 -1 FLEXT)
	string(TOUPPER "SO_${FLNAME}_${FLEXT}_H" COIN_HEADER_DEF)
	string(TOUPPER ${FLNAME} COIN_TEXTVAR_NAME)
	set(COIN_TEXTVAR_NAME "${COIN_TEXTVAR_NAME}${postfx}")
	#message(STATUS "Parse: ${CMAKE_SOURCE_DIR}/${input}")
	FILE(READ ${CMAKE_SOURCE_DIR}/${input} f0)
	STRING(REGEX REPLACE "\\\\" "\\\\\\\\" f1 "${f0}")
	STRING(REGEX REPLACE "\"" "\\\\\"" f2 "${f1}")
	STRING(REGEX REPLACE "\r?\n" "\\\\n\"\n  \"" COIN_STR_SOURCE_CODE "${f2}")
	configure_file(strfytemplate.cmake.in "${FLPATH}/${FLNAME}.h")
endmacro()

file(GLOB_RECURSE COIN_SHADER_GLSL RELATIVE ${CMAKE_SOURCE_DIR} *.glsl)
foreach(INPUTFILE ${COIN_SHADER_GLSL})
    strfy(${INPUTFILE} "_shadersource")
endforeach(INPUTFILE)
file(GLOB_RECURSE COIN_SHADER_INVENTOR RELATIVE ${CMAKE_SOURCE_DIR} *.iv)
foreach(INPUTFILE ${COIN_SHADER_INVENTOR})
    strfy(${INPUTFILE} "_draggergeometry")
endforeach(INPUTFILE)

=== include/CMakeLists.txt ===
add_subdirectory(Inventor)
install(DIRECTORY Inventor/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor COMPONENT development FILES_MATCHING PATTERN "*.h")
install(FILES SoWinEnterScope.h SoWinLeaveScope.h SoDebug.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT development)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_SOURCE_DIR}/include/SoDebug.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== src/CMakeLists.txt ===
# The following two-stage generation of config.h replaces configure_file(config.h.cmake.in config.h)
# and is necessary for the proper definition of COIN_SYSTEM_LIBRARY_NAME in config.h.
# Ref. https://public.kitware.com/pipermail/cmake/2015-April/060350.html
# Deal with @...@ configurable items:
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h_at_configured"
    @ONLY
    )
# Deal with items configured with generator expressions:
  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
    INPUT
    "${CMAKE_CURRENT_BINARY_DIR}/config.h_at_configured"
    )
configure_file(setup.h.cmake.in setup.h)

add_definitions(-DCOIN_INTERNAL -DHAVE_CONFIG_H)

add_compile_options(-DCOIN_DEBUG=$<CONFIG:Debug>)

include_directories(BEFORE
  "${CMAKE_BINARY_DIR}/include"
  "${CMAKE_SOURCE_DIR}/include"
  "${CMAKE_CURRENT_BINARY_DIR}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${CMAKE_SOURCE_DIR}/include/Inventor/annex"
  "${CMAKE_BINARY_DIR}/data"
)

# add include dirs for non targets
if(NOT "${COIN_TARGET_INCLUDE_DIRECTORIES}" STREQUAL "")
  include_directories("${COIN_TARGET_INCLUDE_DIRECTORIES}")
endif()
# add include dirs for targets
foreach(tgt ${COIN_TARGET_LINK_LIBRARIES})
  if(TARGET ${tgt} )
    include_directories($<TARGET_PROPERTY:${tgt},INTERFACE_INCLUDE_DIRECTORIES>)
  endif()
endforeach()

set(COIN_SOURCE tidbits.cpp CACHE INTERNAL "COIN_SOURCE")
set(SUBDIRS
  extensions xml actions base bundles caches details draggers elements
  engines errors events fields fonts glue io manips misc rendering lists nodekits
  navigation nodes shapenodes projectors sensors upgraders
  3ds collision hardcopy shadows geo threads shaders profiler
  vrml97 foreignfiles scxml soscxml
)

foreach(SUBDIR ${SUBDIRS})
  add_subdirectory(${SUBDIR})
endforeach()
add_subdirectory(doc)

if(COIN_BUILD_SHARED_LIBS)
  set(COIN_LIBRARY_TYPE SHARED)
  if(WIN32)
    configure_file(${PROJECT_NAME}.rc.cmake.in ${PROJECT_NAME}.rc)
    set(COIN_SOURCE ${COIN_SOURCE} "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.rc")
  endif()
else()
  set(COIN_LIBRARY_TYPE STATIC)
endif()

if(COIN_BUILD_SINGLE_LIB)
  add_library(${PROJECT_NAME} ${COIN_LIBRARY_TYPE} tidbits.cpp ${COIN_SOURCE})
else()
  if(NOT HAVE_EXPAT)
    set(expat_target $<TARGET_OBJECTS:expat>)
  endif()

  add_library(${PROJECT_NAME} ${COIN_LIBRARY_TYPE} tidbits.cpp
    $<TARGET_OBJECTS:3ds>
    $<TARGET_OBJECTS:actions>
    $<TARGET_OBJECTS:base>
    $<TARGET_OBJECTS:bundles>
    $<TARGET_OBJECTS:caches>
    $<TARGET_OBJECTS:collision>
    $<TARGET_OBJECTS:details>
    $<TARGET_OBJECTS:draggers>
    $<TARGET_OBJECTS:elements>
    $<TARGET_OBJECTS:engines>
    $<TARGET_OBJECTS:errors>
    $<TARGET_OBJECTS:events>
    ${expat_target}
    $<TARGET_OBJECTS:fields>
    $<TARGET_OBJECTS:fonts>
    $<TARGET_OBJECTS:foreignfiles>
    $<TARGET_OBJECTS:geo>
    $<TARGET_OBJECTS:glelements>
    $<TARGET_OBJECTS:glue>
    $<TARGET_OBJECTS:hardcopy>
    $<TARGET_OBJECTS:io>
    $<TARGET_OBJECTS:lists>
    $<TARGET_OBJECTS:manips>
    $<TARGET_OBJECTS:misc>
    $<TARGET_OBJECTS:navigation>
    $<TARGET_OBJECTS:nodekits>
    $<TARGET_OBJECTS:nodes>
    $<TARGET_OBJECTS:profiler>
    $<TARGET_OBJECTS:projectors>
    $<TARGET_OBJECTS:rendering>
    $<TARGET_OBJECTS:scxml>
    $<TARGET_OBJECTS:sensors>
    $<TARGET_OBJECTS:shaders>
    $<TARGET_OBJECTS:shadows>
    $<TARGET_OBJECTS:shapenodes>
    $<TARGET_OBJECTS:soscxml>
    $<TARGET_OBJECTS:threads>
    $<TARGET_OBJECTS:upgraders>
    $<TARGET_OBJECTS:vrml97>
    $<TARGET_OBJECTS:xml>
    ${COIN_SOURCE}
  )
endif()

if(WIN32)
  if(COIN_BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} INTERFACE COIN_DLL)
  else()
    target_compile_definitions(${PROJECT_NAME} INTERFACE COIN_NOT_DLL)
  endif()
endif()

if(MSVC)
  if(NOT COIN_BUILD_SHARED_LIBS)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /Z7")                       # Override default /Zi to embed
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Z7")     # debugging info in the .lib.
  endif()
  # Suppress warning about empty switch statement in Bison-generated files:
  set_property(SOURCE scxml/eval-minimum-tab.cpp APPEND PROPERTY COMPILE_FLAGS /wd4065)
  set_property(SOURCE soscxml/eval-coin-tab.cpp APPEND PROPERTY COMPILE_FLAGS /wd4065)
endif()

target_include_directories(${PROJECT_NAME} PRIVATE "${COIN_TARGET_INCLUDE_DIRECTORIES}")
target_link_libraries(${PROJECT_NAME} PRIVATE "${COIN_TARGET_LINK_LIBRARIES}")
target_include_directories(${PROJECT_NAME} INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>)

set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${COIN_SO_VERSION})

# ############################################################################
# Install binaries and config package
# ############################################################################

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime NAMELINK_SKIP
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development
)

if(COIN_BUILD_SHARED_LIBS)
  install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT development NAMELINK_ONLY)
  if(MSVC)
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${CMAKE_INSTALL_BINDIR} CONFIGURATIONS Debug RelWithDebInfo COMPONENT debug)
  endif()
endif()

# Support find_package(Coin NO_MODULE).
set(COIN_DOC_DIR ${CMAKE_INSTALL_DOCDIR})
set(COIN_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(COIN_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
set(COINDIR ${CMAKE_INSTALL_PREFIX})
include(CMakePackageConfigHelpers)

configure_package_config_file(${PROJECT_NAME_LOWER}-config.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  PATH_VARS COINDIR COIN_INCLUDE_DIR COIN_LIB_DIR COIN_DOC_DIR
)

write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
)

# To make the component usable not only from the install directory but also from the build directory
export(
  TARGETS ${PROJECT_NAME}
  FILE ${PROJECT_NAME_LOWER}-export.cmake
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME_LOWER}-config-version.cmake"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  COMPONENT development
)

install(EXPORT ${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME_LOWER}-export.cmake
  COMPONENT development
)

=== testsuite/CMakeLists.txt ===
macro(create_testsuite input)
	get_filename_component(FLNAME "${input}" NAME_WE)
	get_filename_component(FLPATH "${input}" PATH)
	string(REGEX REPLACE ".*[/\\]" "" FLSUBFLD "${FLPATH}")
	set(COIN_STR_TEST_CLASS "${FLNAME}")
	file(READ ${CMAKE_SOURCE_DIR}/${input} f0)
	if(f0 MATCHES "#ifdef[ \t]+COIN_TEST_SUITE")
		# message(STATUS "Parse: ${CMAKE_SOURCE_DIR}/${input} - ${FLPATHSUB}${FLNAME}Test.cpp")
		# get first include from file, which we assume is include to tested class
		string(REGEX MATCH "[\n\r]+#include[ \t]<[^\n]+" iclass "${f0}")
		# get block between '#ifdef COIN_TEST_SUITE' and '#endif'
		string(REGEX REPLACE ".*#ifdef[ \t]+COIN_TEST_SUITE" "" f1 "${f0}")
		string(REGEX REPLACE "#endif[ \t/!]+COIN_TEST_SUITE.*" "" f2 "${f1}")
		# get all #include statements within COIN_TEST_SUITE code block
		string(REGEX MATCHALL "#include[ \t]<[^\n]+" i0 "${f2}")
		string(REPLACE ";" "\n" COIN_STR_TEST_INCL "${i0}")
		set(COIN_STR_TEST_INCL "${iclass}\n${COIN_STR_TEST_INCL}")
		# remove #include statements from test code string (moved to ${COIN_STR_TEST_INCL})
		string(REGEX REPLACE "[\n\r ]*#include[ \t]<[^\n]+" "" COIN_STR_TEST_CODE "${f2}")
		# generate new test code file with extracted snippets
		configure_file(TestSuiteTemplate.cmake.in "${FLSUBFLD}${FLNAME}Test.cpp")
	endif()
endmacro()

macro(create_file_test input testfunc filter)
	file(GLOB_RECURSE COIN_IV_FILES RELATIVE ${CMAKE_SOURCE_DIR} ../${input}/*.wrl ../${input}/*.vrml ../${input}/*.gz ../${input}/*.iv)
	string(REGEX REPLACE "[\\./\\-]+" "" TESTSUITENAME "${input}")
	set(COIN_STR_TEST_INCL "")
	set(COIN_STR_TEST_CODE "const char *readError[] = { \"Coin read error:\", 0 };\n")
	set(COIN_STR_TEST_CLASS "${TESTSUITENAME}")
	set(extra_macro_args ${ARGN})
	list(LENGTH extra_macro_args num_extra_args)
	foreach(INPUTFILE ${COIN_IV_FILES})
		if(${num_extra_args} EQUAL 0 OR NOT ("${INPUTFILE}" MATCHES "${extra_macro_args}"))
			string(REGEX REPLACE "[\\./\\-]+" "_" TESTNAME "${INPUTFILE}")
			if (${filter})
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { PushMessageSuppressFilters(readError); ResetReadErrorCount(); test_file(\"${CMAKE_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); PopMessageSuppressFilters(); }")
			else()
				set(COIN_STR_TEST_CODE "${COIN_STR_TEST_CODE}\nBOOST_AUTO_TEST_CASE(${TESTNAME}) { ResetReadErrorCount(); test_file(\"${CMAKE_SOURCE_DIR}/${INPUTFILE}\", &${testfunc}); }")
			endif()
		endif()
	endforeach()
	configure_file(TestSuiteTemplate.cmake.in "${TESTSUITENAME}Test.cpp")
endmacro()

# Parse all source files for embedded '#ifdef COIN_TEST_SUITE' and extract those blocks
# to separate test source files.
file(GLOB_RECURSE COIN_SRC_FILES RELATIVE ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/*.cpp)
foreach(INPUTFILE ${COIN_SRC_FILES})
	create_testsuite(${INPUTFILE})
endforeach()

# Create test cases for all scenes under models folder (this replaces StandardTests.cpp).
# The original StandardTests.cpp also tested additional folders:
# - "killers" with testInCorrectFile
# - "slackers" with testOutOfSpecFile
# However, those folders are not in the repository.
create_file_test("models" "testCorrectFile" false "incorrect")
# bug039.iv and bug055-5.iv contain errors but load anyway: ignore for now
create_file_test("models/io/incorrect" "testIncorrectFile" true "(bug039|bug055-5)")

# Include all extracted '*Tests.cpp' files in the target.
FILE(GLOB COIN_TEST_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/*Test.cpp")

add_executable(CoinTests TestSuiteMain.cpp TestSuiteUtils.cpp TestSuiteMisc.cpp ${COIN_TEST_SOURCES})
target_link_libraries(CoinTests Coin ${COIN_TARGET_LINK_LIBRARIES})
target_include_directories(CoinTests PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/include
	${CMAKE_SOURCE_DIR}/include/Inventor/annex
	${CMAKE_BINARY_DIR}/include
)
if (USE_PTHREAD)
	target_link_libraries(CoinTests pthread)
endif()
add_test(NAME CoinTests COMMAND CoinTests)

# Many warnings are generated from test macros on macOS with Xcode.
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wtautological-compare DISABLE_WARNING_TAUTOLOGCOMPARE)
if(DISABLE_WARNING_TAUTOLOGCOMPARE)
	target_compile_options(CoinTests PUBLIC -Wno-tautological-compare)
endif()

=== include/Inventor/CMakeLists.txt ===
add_subdirectory(C)
add_subdirectory(system)
file(GLOB_RECURSE HDRS *.h)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${HDRS}
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== src/details/CMakeLists.txt ===
# source files
set(COIN_DETAILS_FILES
	SoDetail.cpp
	SoConeDetail.cpp
	SoCubeDetail.cpp
	SoCylinderDetail.cpp
	SoFaceDetail.cpp
	SoLineDetail.cpp
	SoNodeKitDetail.cpp
	SoPointDetail.cpp
	SoTextDetail.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_DETAILS_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} details/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(details OBJECT ${COIN_DETAILS_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_DETAILS_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/details/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== src/doc/CMakeLists.txt ===
# Add a target to generate API documentation with Doxygen
if(COIN_BUILD_DOCUMENTATION)
  find_package(Doxygen)
  if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
  endif()

# ############################################################################
# Setup documentation options
# ############################################################################
  set(GENERATE_HTMLHELP NO)
  set(DOXYGEN_GENERATE_MAN NO)
  set(GENERATE_QHP NO)
  set(GENERATE_TREEVIEW YES)
  set(HHC_PROGRAM)
  if(WIN32)
    if(COIN_BUILD_DOCUMENTATION_CHM)
      find_program(HHC_PROGRAM NAMES hhc.exe PATHS "C:/Program Files/HTML Help Workshop" "C:/Program Files (x86)/HTML Help Workshop" DOC "HTML Help Compiler program")
      if(NOT HHC_PROGRAM)
        message(FATAL_ERROR "Missing program HTML Help Compiler")
      else()
        set(GENERATE_HTMLHELP YES)
        set(GENERATE_TREEVIEW NO)
        mark_as_advanced(HHC_PROGRAM)
      endif()
    endif()
  else()
    if(COIN_BUILD_DOCUMENTATION_MAN)
      set(DOXYGEN_GENERATE_MAN YES)
    endif()
  endif()
  if(COIN_BUILD_DOCUMENTATION_QTHELP)
    find_program(QHG_LOCATION NAMES qhelpgenerator qhelpgenerator-qt5 DOC "Qt qhelpgenerator")
    if(NOT QHG_LOCATION)
      message(FATAL_ERROR "Missing program Qt qhelpgenerator")
    else()
      set(GENERATE_QHP YES)
      mark_as_advanced(QHG_LOCATION)
    endif()
  endif()

  # Add default files
  file(GLOB_RECURSE DOX *.dox*)
  set(COIN_DOCUMENTATION_FILES
    ${COIN_DOCUMENTATION_FILES}
    "${CMAKE_SOURCE_DIR}/docs/releases.dox"
    ${DOX}
    CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
  )

  set(DOXYGEN_INTERNAL_DOCS NO)
  set(DOXYGEN_EXTRACT_PRIVATE NO)
  set(DOXYGEN_WARN_IF_UNDOCUMENTED YES)
  set(DOXYGEN_EXCLUDE)
  if(COIN_BUILD_INTERNAL_DOCUMENTATION)
    set(DOXYGEN_INTERNAL_DOCS YES)
    set(DOXYGEN_EXTRACT_PRIVATE YES)
    set(DOXYGEN_WARN_IF_UNDOCUMENTED NO)
    set(COIN_DOCUMENTATION_FILES
      ${COIN_DOCUMENTATION_FILES}
      ${COIN_INTERNAL_DOCUMENTATION_FILES}
      CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
    )
  else()
    set(COIN_DOCUMENTATION_EXCLUDE_SYMBOLS SoProfilerP)
    foreach(XF ${COIN_INTERNAL_DOCUMENTATION_FILES})
      set(DOXYGEN_EXCLUDE "${DOXYGEN_EXCLUDE}                         ${XF} \\\n")
    endforeach()
  endif()
  set(DOXYGEN_INPUT)
  list(REMOVE_DUPLICATES COIN_DOCUMENTATION_FILES)
  foreach(XF ${COIN_DOCUMENTATION_FILES})
    set(DOXYGEN_INPUT "${DOXYGEN_INPUT}                         ${XF} \\\n")
  endforeach()
  set(DOXYGEN_INPUT "${DOXYGEN_INPUT}                         ${CMAKE_SOURCE_DIR}/src/tidbits.cpp")
  set(DOXYGEN_EXCLUDE_SYMBOLS)
  foreach(XF ${COIN_DOCUMENTATION_EXCLUDE_SYMBOLS})
    set(DOXYGEN_EXCLUDE_SYMBOLS "${DOXYGEN_EXCLUDE_SYMBOLS}                         ${XF} \\\n")
  endforeach()

  set(DOXYFILE "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
  set(DOXYGEN_OUTPUT "${CMAKE_BINARY_DIR}/html/index.html")
  configure_file("${CMAKE_SOURCE_DIR}/docs/coin.doxygen.cmake.in" ${DOXYFILE} @ONLY)

# ############################################################################
# Setup documentation targets
# ############################################################################
  add_custom_command(
    OUTPUT ${DOXYGEN_OUTPUT}
    COMMAND ${CMAKE_COMMAND} -E echo_append "Generating API documentation with Doxygen "
    COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
    COMMAND ${CMAKE_COMMAND} -E echo "done."
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${DOXYFILE}
  )
  add_custom_target(documentation ALL DEPENDS ${DOXYGEN_OUTPUT})

# ############################################################################
# Install built documentation files
# ############################################################################
  install(DIRECTORY "${CMAKE_BINARY_DIR}/html" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation REGEX ".*\\.(chm|qch)" EXCLUDE)
  if(GENERATE_HTMLHELP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}.chm" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(GENERATE_QHP)
    install(FILES "${CMAKE_BINARY_DIR}/html/${PROJECT_NAME}.qch" DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT documentation)
  endif()
  if(DOXYGEN_GENERATE_MAN)
    install(DIRECTORY "${CMAKE_BINARY_DIR}/man/man3" DESTINATION ${CMAKE_INSTALL_MANDIR} COMPONENT documentation)
    message(STATUS "CMAKE_INSTALL_MANDIR ${CMAKE_INSTALL_MANDIR}")
  endif()
endif()

=== src/misc/CMakeLists.txt ===
# source files
set(COIN_MISC_FILES
	AudioTools.cpp
	CoinStaticObjectInDLL.cpp
	SoAudioDevice.cpp
	SoBase.cpp
	SoBaseP.cpp
	SoChildList.cpp
	SoCompactPathList.cpp
	SoConfigSettings.cpp
	SoContextHandler.cpp
	SoDB.cpp
	SoDebug.cpp
	SoFullPath.cpp
	SoGenerate.cpp
	SoGlyph.cpp
	SoInteraction.cpp
	SoJavaScriptEngine.cpp
	SoLightPath.cpp
	SoLockManager.cpp
	SoNormalGenerator.cpp
	SoNotRec.cpp
	SoNotification.cpp
	SoPath.cpp
	SoPick.cpp
	SoPickedPoint.cpp
	SoPrimitiveVertex.cpp
	SoProto.cpp
	SoProtoInstance.cpp
	SoSceneManager.cpp
	SoSceneManagerP.cpp
	SoShaderGenerator.cpp
	SoState.cpp
	SoTempPath.cpp
	SoType.cpp
	CoinResources.cpp
	SoDBP.cpp
	SoEventManager.cpp
)

# Files excluded from public API documentation, included in complete documentation.
set(COIN_MISC_INTERNAL_FILES
	AudioTools.h
	AudioTools.cpp
	CoinStaticObjectInDLL.h
	CoinStaticObjectInDLL.cpp
	SbHash.h
	SoBaseP.h
	SoBaseP.cpp
	SoCompactPathList.h
	SoCompactPathList.cpp
	SoConfigSettings.h
	SoConfigSettings.cpp
	SoDBP.h
	SoDBP.cpp
	SoGenerate.h
	SoGenerate.cpp
	SoPick.h
	SoPick.cpp
	SoSceneManagerP.h
	SoSceneManagerP.cpp
	SoShaderGenerator.h
	SoShaderGenerator.cpp
)

# build library
if(COIN_BUILD_SINGLE_LIB)
	foreach(SRCFILE ${COIN_MISC_FILES})
		set(COIN_SOURCE ${COIN_SOURCE} misc/${SRCFILE} CACHE INTERNAL "COIN_SOURCE")
	endforeach(SRCFILE)
else()
	add_library(misc OBJECT ${COIN_MISC_FILES})
endif()

# define documentation
foreach(SRCFILE ${COIN_MISC_FILES})
	set(COIN_DOCUMENTATION_FILES ${COIN_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/misc/${SRCFILE} CACHE INTERNAL "COIN_DOCUMENTATION_FILES")
endforeach(SRCFILE)
foreach(SRCFILE ${COIN_MISC_INTERNAL_FILES})
	set(COIN_INTERNAL_DOCUMENTATION_FILES ${COIN_INTERNAL_DOCUMENTATION_FILES} ${CMAKE_SOURCE_DIR}/src/misc/${SRCFILE} CACHE INTERNAL "COIN_INTERNAL_DOCUMENTATION_FILES")
endforeach(SRCFILE)

=== include/Inventor/C/CMakeLists.txt ===
configure_file(basic.h.cmake.in basic.h)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basic.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor/C COMPONENT development)
set(COIN_DOCUMENTATION_FILES
	${COIN_DOCUMENTATION_FILES}
	${CMAKE_CURRENT_BINARY_DIR}/basic.h
	CACHE INTERNAL "COIN_DOCUMENTATION_FILES"
)

=== include/Inventor/system/CMakeLists.txt ===
if(WIN32)
    set(SIM_INCLUDE_WINDOWS_H "#include <windows.h>")
endif()
if(APPLE)
    set(SIM_INCLUDE_GL_H "#include <OpenGL/gl.h>")
else()
    set(SIM_INCLUDE_GL_H "#include <GL/gl.h>")
endif()
configure_file(gl-headers.h.cmake.in gl-headers.h)
configure_file(inttypes.h.cmake.in inttypes.h)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gl-headers.h ${CMAKE_CURRENT_BINARY_DIR}/inttypes.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Inventor/system COMPONENT development)

=== debian/changelog ===
coin3 (4.0.0~CMake~6f54f1602475+ds1-2) unstable; urgency=medium

  * Fix autopkgtest.
  * Set Standards-Version: 4.3.0. No changes.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Thu, 24 Jan 2019 10:33:15 +0100

coin3 (4.0.0~CMake~6f54f1602475+ds1-1) unstable; urgency=medium

  * Transition from experimental to unstable. Closes: #914392

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 19 Dec 2018 23:03:29 +0100

coin3 (4.0.0~CMake~6f54f1602475+ds1-1~exp2) experimental; urgency=medium

  * Added Conflicts in libcoin-dev to inventor-dev. Closes: #914686
  * We are not using (CMake version) the embed expat library. Closes: #560928

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 26 Nov 2018 13:23:12 +0100

coin3 (4.0.0~CMake~6f54f1602475+ds1-1~exp1) experimental; urgency=medium

  [ Anton Gladky ]
  * Remove testsuite-files from d/control
  * Use Breaks/Replaces. Remove old libs-confilcts
  * Do not introduce privacy breach
  * Mangle ds-version in d/watch

  [ Leopold Palomo-Avellaneda ]
  * New upstream version 6f54f1602475 (20181007)
  * Added cmake files
  * Update changelog
  * Renamed package dropping v5 suffix to c
  * Drop the moved files
  * Delete trailing whitespaces in changelog
  * Added myself as Uploader
  * Drop unused files
  * Delete Breaks and replaces changed to libcoin80v5
  * Improved rules to use CMake
  * Renamed libcoin80-dev to libcoin-dev
  * Rename libcoin80-doc to libcoin-doc
  * Rename libcoin80-runtime to libcoin-runtime
  * Bump standards version. No changes
  * Improve libcoin-doc long description
  * Bump debhelper dependency to 11
  * Use of system expat library. Added as build dependency. (Closes: #884947)

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 14 Nov 2018 15:19:01 +0100

coin3 (4.0.0~CMake~1d5b2270e495+dfsg1-1~exp1) experimental; urgency=medium

  * [ee4f2fa] New upstream version 4.0.0~CMake~1d5b2270e495+dfsg1
  * [77535c3] Add Readme.source
  * [0899133] Refresh patches
  * [e533e12] Update due to a new release
  * [88ca1a5] Add myself to uploaders again
  * [52a0f11] Apply cme fix dpkg

 -- Anton Gladky <gladk@debian.org>  Wed, 27 Dec 2017 00:24:51 +0100

=== debian/control ===
Source: coin3
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>, Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               doxygen,
               libexpat-dev,
               libgl1-mesa-dev,
               libx11-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               libxpm-dev,
               libxt-dev,
               libboost-all-dev,
               freeglut3-dev
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/coin3
Vcs-Git: https://salsa.debian.org/science-team/coin3.git
Homepage: https://bitbucket.org/Coin3D/coin/

Package: libcoin80c
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libbz2-1.0,
          libfreetype6,
          libopenal0a,
          libsimage-dev,
          zlib1g
Pre-Depends: ${misc:Pre-Depends}
Replaces: libcoin80v5
Description: high-level 3D graphics kit implementing the Open Inventor API
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.  Installing the suggested packages will enable
 extra features:
 .
     libsimage-dev enables loading of image files in SbImage
     libfreetype6 enables use of TrueType fonts
     libopenal0a   enables audio support
     zlib1g and libbz2 enable transparent read of compressed files

Package: libcoin-dev
Architecture: any
Section: libdevel
Depends: libcoin80c (= ${binary:Version}),
         libgl1-mesa-dev | libgl-dev,
         libx11-dev,
         libxext-dev,
         libxi-dev,
         libxmu-dev,
         libxpm-dev,
         libxt-dev,
         ${misc:Depends}
Suggests: libcoin-doc (= ${binary:Version})
Replaces: libcoin80-dev
Breaks: libcoin80-dev
Conflicts: inventor-dev
Description: high-level 3D graphics devkit with Open Inventor and VRML97 support
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libcoin-dev (= ${binary:Version})
Replaces: libcoin80-doc
Breaks: libcoin80-doc
Description: high-level 3D graphics kit with Open Inventor and VRML97 support
 API documentation for the Coin library (the Open Inventor API) in
 HTML format.
 .
 Coin is an OpenGL-based, retain-mode 3D graphics library that
 implements the Open Inventor 2.1 API. It also includes support for
 VRML97 and 3D audio.

Package: libcoin-runtime
Architecture: all
Section: libs
Depends: ${misc:Depends}
Suggests: libcoin80c
Replaces: libcoin80-runtime
Breaks: libcoin80-runtime
Description: high-level 3D graphics kit - external data files
 External data files used by the Coin library at run-time.  The
 dragger geometry files represent the defaults that are used if the
 files are not found.  This package is completely optional.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_OPTIONS += nocheck
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
        MAKEFLAGS += -j$(NUMJOBS)
endif

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
#unexport CFLAGS
#unexport CXXFLAGS
#unexport LDFLAGS

CMAKE_FLAGS = \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
        -DCMAKE_VERBOSE_MAKEFILE=ON \
        -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
        -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
        -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
        -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
        -DUSE_EXTERNAL_EXPAT=ON

%:
	dh $@ --buildsystem=cmake --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS)

override_dh_installdocs:
	dh_installdocs
	find $(CURDIR)/debian/libcoin-doc/ -type f -print0 | xargs --no-run-if-empty -0 sed -i 's/http:\/\/www\.web3d\.org//g'

=== debian/tests/control ===
Tests: build1
Depends: libcoin-dev, freeglut3-dev, build-essential, xvfb, xauth

## coin3 4.0.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: coin3
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Anton Gladky <gladk@debian.org>, Leopold Palomo-Avellaneda <leo@alaxarxa.net>
+Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
 Section: graphics
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                doxygen,
                libexpat-dev,
-               libgl1-mesa-dev,
                libx11-dev,
                libxext-dev,
                libxi-dev,
@@ -15,14 +14,20 @@
                libxpm-dev,
                libxt-dev,
                libboost-all-dev,
-               freeglut3-dev
-Standards-Version: 4.3.0
+               freeglut3-dev,
+	       libgl-dev,
+	       libglvnd-dev,
+	       libopengl-dev,
+ 	       libglew-dev
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/coin3
 Vcs-Git: https://salsa.debian.org/science-team/coin3.git
-Homepage: https://bitbucket.org/Coin3D/coin/
+Homepage: https://github.com/coin3d
 
 Package: libcoin80c
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
@@ -48,7 +53,9 @@
 Architecture: any
 Section: libdevel
 Depends: libcoin80c (= ${binary:Version}),
-         libgl1-mesa-dev | libgl-dev,
+         libgl-dev,
+	 libopengl-dev,
+	 libglew-dev,
          libx11-dev,
          libxext-dev,
          libxi-dev,
@@ -67,6 +74,7 @@
 
 Package: libcoin-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Suggests: libcoin-dev (= ${binary:Version})
@@ -82,6 +90,7 @@
 
 Package: libcoin-runtime
 Architecture: all
+Multi-Arch: foreign
 Section: libs
 Depends: ${misc:Depends}
 Suggests: libcoin80c
